package jPython;

import java.io.FileNotFoundException;
import java.io.FileReader;
import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("jPython")
@Version(1.05f)
@Author("Daestrum")
public class jPython {
	private static Invocable invo = null;

	public jPython() {
	}

	public static Object Invoke(String func, Object... args) {
		Object reply = null;
		try {
			reply = invo.invokeFunction(func, args);
		} catch (NoSuchMethodException | ScriptException e) {
			e.printStackTrace();
		}
		return reply;
	}

	public static void InitInvocable(String script) {
		if (invo != null)
			return;
		System.out.println("engines :" + new ScriptEngineManager().getEngineFactories());
		ScriptEngine engine = new ScriptEngineManager().getEngineByName("python");
		if (engine == null)
			System.out.println("failed to acquire script engine");
		if (engine != null) {
			if (script.endsWith(".py")) {
				try {
					engine.eval(new FileReader(script));
				} catch (FileNotFoundException fnf) {
					System.out.println("file " + script + " not found");
				} catch (ScriptException se) {
					System.out.println("Script error " + se);
				}
			} else {
				try {
					engine.eval(script);
				} catch (ScriptException se) {
					System.out.println("Script error " + se);
				}
			}
			Invocable invocable = (Invocable) engine;
			invo = invocable;
		}
	}
}
